<!DOCTYPE html>
<html lang="en">

<head>
  <title>Task 22.20</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- font -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Lato">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
</head>

<body onload="onPageLoading()">
  <div class="container">
    <h2 class="text-center">Danh sách người dùng đăng ký</h2>
    <table id="user-table" class="table table-bordered table-striped table-hover">
      <thead>
        <tr>
          <th>Mã người dùng</th>
          <th>Firstname</th>
          <th>Lastname</th>
          <th>Age</th>
          <th>Action</th>
        </tr>
      </thead>
      <tbody>

      </tbody>
    </table>
  </div>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gJSON_USER = `{
    "description": "Data user",
    "users": [
      {
        "userId": 1,
        "firstname": "Nguyễn",
        "lastname": "Hoa Lan",
        "age": 18
      },
      {
        "userId": 2,
        "firstname": "Trần",
        "lastname": "Hòa Bình",
        "age": 19
      },
      {
        "userId": 3,
        "firstname": "Joe",
        "lastname": "Paker",
        "age": 18
      },
      {
        "userId": 4,
        "firstname": "Lee",
        "lastname": "Hoyan",
        "age": 20
      },
      {
        "userId": 5,
        "firstname": "Mai",
        "lastname": "Thế Vinh",
        "age": 21
      },
      {
        "userId": 6,
        "firstname": "Sadam",
        "lastname": "Mark",
        "age": 20
      }
    ]
  }`;
    // parsing json to object
    var gUserListObject = JSON.parse(gJSON_USER);

    const gEND_ROW_TABLE = -1;
    // hằng số số thứ tự các cột
    const gCOLUMN_USER_ID = 0;
    const gCOLUMN_FIRSTNAME = 1;
    const gCOLUMN_LASTNAME = 2;
    const gCOLUMN_AGE = 3;
    const gCOLUMN_ACTION = 4;

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */


    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // hàm xử lý sự kiện loading
    function onPageLoading() {
      // hiển thị dữ liệu lên table
      showDataOnTable(gUserListObject.users);

      function findLastCell(paramStr) {
        var vCurrentCell;
        $("#user-table tr").find("td:eq(" + gCOLUMN_LASTNAME + ")").each(function ()   //trong tất cả các  
        {
          if ($(this).text() == paramStr)
            vCurrentCell = $(this);
        });
        return vCurrentCell;
      }
      console.log(findLastCell("Paker").html());
      findLastCell("Paker").closest('tr').find("td:eq(0)").text();
      //findCell("Trần").closest('tr').find("td:eq(4)").text();
      //$("#user-table tr").find("th:eq(0)").text();
      //$("#user-table tr").find("th:eq(0)").text();
    }

    //hàm xử lý sự kiện chung cho tất cả các nút Chi tiết
    // onBtnChiTietClick, ấn nút chi tiết 
    function onBtnChiTietClick(paramDetailButton) {
      // thu thập dữ liệu
      var vId = paramDetailButton.dataset.id;
      var vFirstname = paramDetailButton.dataset.firstname;
      var vLastname = paramDetailButton.dataset.lastname;
      var vAge = paramDetailButton.dataset.age;

      // gọi và truyền data qua form Details
      console.log("%c Ghi thông tin hàng ra console", "color:blue");
      console.log("First name = " + vFirstname);
      console.log(paramDetailButton.dataset);
    }


    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // hiển thị dữ liệu lên table
    function showDataOnTable(paramUserList) {
      var vTable = document.getElementById("user-table");
      var vTableBody = vTable.getElementsByTagName("tbody")[0];

      for (var bIndex = 0; bIndex < paramUserList.length; bIndex++) {
        var vUser = paramUserList[bIndex];
        // tạo dòng mưới cho bẳng và ghi vào các giá trị 
        var row = vTableBody.insertRow(-1);

        var vCellUserId = row.insertCell(gCOLUMN_USER_ID);
        var vCellFirstname = row.insertCell(gCOLUMN_FIRSTNAME);
        var vCellLastname = row.insertCell(gCOLUMN_LASTNAME);
        var vCellAge = row.insertCell(gCOLUMN_AGE);
        var vCellAction = row.insertCell(gCOLUMN_ACTION);

        vCellUserId.innerHTML = vUser.userId;
        vCellFirstname.innerHTML = vUser.firstname;
        vCellLastname.innerHTML = vUser.lastname;
        vCellAge.innerHTML = vUser.age;
        //vCellAction.innerHTML = "Chi tiết";
        // thêm data
        // thêm data vào các dòng của button

        var vDetailButton = document.createElement("button"); //tạo element button
        vCellAction.appendChild(vDetailButton); // gắn nó vào ô (cell)

        vDetailButton.innerHTML = "Chi tiết"; //thêm label (nhãn của  button)
        vDetailButton.className = "btn btn-info info-user";  //kiểu button bootstrap và "info-user" là class để truy cập button sau này 
        vDetailButton.setAttribute("data-id", vUser.userId);  //gán userID vào dataset của button
        vDetailButton.setAttribute("data-firstname", vUser.firstname); // gán firstname vào dataset của button
        vDetailButton.setAttribute("data-lastname", vUser.lastname);
        vDetailButton.setAttribute("data-age", vUser.age);
        //add event listener
        vDetailButton.addEventListener('click', function () {
          onBtnChiTietClick(this);
        });
      }
    }


  </script>

</body>
<script>
  // script dùng Jquery Selector and Traversing


</script>

</html>